﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;

namespace WinGridExcelHiperLink
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("Column", typeof(string));
            string path = Application.StartupPath;
            FileStream fs =File.Create(path + "\\MyFile.txt");
            fs.Close();
            table.Rows.Add(path + "\\MyFile.txt");
            ultraGrid1.DataSource = table;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {   
            e.Layout.Bands[0].Columns[0].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.URL;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.Export(ultraGrid1, "Test.xlsx");

            Process.Start("Test.xlsx");
        }

        private void ultraGridExcelExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportingEventArgs e)
        {

        }

        private void ultraGridExcelExporter1_CellExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {
            if (e.GridColumn.Style == Infragistics.Win.UltraWinGrid.ColumnStyle.URL)
            {
                try
                {
                    string val = (string)e.Value;
                    string displaytext = val.Substring(val.LastIndexOf('\\') + 1);
                    string hiperlink = string.Format("=HYPERLINK(\"{0}\",\"{1}\")", val, displaytext);
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].ApplyFormula(hiperlink);//"=HYPERLINK(\"C:\\MyFile.txt\",\"MyFile.txt\")");
                }
                catch { }
            }
        }
    }
}
